package require Tk

wm title . "Milliseconds per Beat"
grid [ttk::frame .c -padding "3 3 12 12"] -column 0 -row 0 -sticky nwes
grid columnconfigure . 0 -weight 1; grid rowconfigure . 0 -weight 1

grid [ttk::entry .c.bpm -width 7 -textvariable bpm] -column 2 -row 1 -sticky we
grid [ttk::label .c.msecs -textvariable msecs] -column 2 -row 2 -sticky we
grid [ttk::button .c.calc -text "Calculate" -command calculate] -column 3 -row 3 -sticky w

grid [ttk::label .c.flbl -text "bpm"] -column 3 -row 1 -sticky w
grid [ttk::label .c.islbl -text "is equivalent to"] -column 1 -row 2 -sticky e
grid [ttk::label .c.mlbl -text "msecs per beat"] -column 3 -row 2 -sticky w

foreach w [winfo children .c] {grid configure $w -padx 5 -pady 5}
focus .c.bpm
bind . <Return> {calculate}

proc calculate {} {  
   if {[catch {
      set ::msecs [expr {(60.0/($::bpm*1000.0))*1000000.0}] 
   }]!=0} {
       set ::msecs ""
   }
}
